/*!
 * @file glgui_fixedposition_box.h
 * The gl_fixedposition_box widget of th openglGUi
 */

#ifndef _GLGUI_FIXEDPOSITION_BOX_H
#define _GLGUI_FIXEDPOSITION_BOX_H

#include "glgui_box.h"
#include "event_listener.h"

namespace OrxGui
{
  //! This is BOX part of the openglGUI class
  /**
   * The Box is always positioned at the designated position on the screen
   *
   * @note If you pack the box or move it with setRel/AbsCoor2D the
   * behaviour of positioning is not predictable!
   */
  class GLGuiFixedpositionBox : public OrxGui::GLGuiBox, EventListener
  {

    public:
      GLGuiFixedpositionBox(OrxGui::Position position = OrxGui::Center, OrxGui::Orientation orientation = OrxGui::Vertical);

      inline OrxGui::Position position() const { return this->_position; };
      void setPosition(OrxGui::Position position);

    protected:
      virtual void resize();
      virtual void process(const Event& event); //!< from eventListener

    private:
      OrxGui::Position     _position;     //!< The Fixed position of the Widget.
  };
}
#endif /* _GLGUI_FIXEDPOSITION_BOX_H */
